local textureswaplist = {
	["GFZFLR01"] = "CFZFLR01",
	["GFZFLR14"] = "CFZFLR01",
	["GFZFLR15"] = "CFZFLR01",
	["GFZROCK"] = "CFZWALL",
	["GFZROCK2"] = "CFZWALL",
	["GFZROCK3"] = "CFZWALL",
	["GFZROCKA"] = "CFZWALL",
	["GFZROCKB"] = "CFZWALL",
	["GFZROCKC"] = "CFZWALL",
	["GFZWALL"] = "CFZWALL",
	["GFZWALL2"] = "CFZWALL",
	["GFZWALLB"] = "CFZWALL",
	["GFZCHEK1"] = "CFZWALL",
	["GFZCHEK2"] = "CFZWALL",
	["GFZCHEKB"] = "CFZWALL",
	["GFZBORD1"] = "CFZWALL",
	["OLDGFZW1"] = "CFZWALL",
	["GFZFLR02"] = "CFZFLR02",
	["GFZFLR10"] = "CFZFLR02",
	["GFZGRSW"] = "CFZGRSW",
	["GFZGRASS"] = "CFZGRASS",
}

local colormap = {
	[1] = ,
	[2] = ,
}

addHook("MapLoad", function()
	for p in players.iterate do
		if not (p.mo and p.mo.valid) then continue end
		if p.mo.skin ~= "specki" then continue end
		
		for sector in sectors.iterate do
			if textureswaplist[sector.floorpic] ~= nil then sector.floorpic = textureswaplist[sector.floorpic] end
			if textureswaplist[sector.ceilingpic] ~= nil then sector.ceilingpic = textureswaplist[sector.ceilingpic] end
		end
		
		for side in sides.iterate do	
			local toptex = R_CheckTextureNameForNum(side.toptexture)
			local midtex = R_CheckTextureNameForNum(side.midtexture)
			local bottex = R_CheckTextureNameForNum(side.bottomtexture)
			
			toptex = string.sub($, 1, 8)
			midtex = string.sub($, 1, 8)
			bottex = string.sub($, 1, 8)
			
			if textureswaplist[toptex] ~= nil then side.toptexture = R_CheckTextureNumForName(textureswaplist[toptex]) end
			if textureswaplist[midtex] ~= nil then side.midtexture = R_CheckTextureNumForName(textureswaplist[midtex]) end
			if textureswaplist[bottex] ~= nil then side.bottomtexture = R_CheckTextureNumForName(textureswaplist[bottex]) end
		end
		
		return
	end
end)