freeslot("MT_SPECKIWAYPOINT")

mobjinfo[MT_SPECKIWAYPOINT] = {
	--$Name "specki ACZ waypoint"
	doomednum = 5192
}

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid) then return end
	if not p.mo.health then return end
	if p.mo.skin ~= "specki" then return end
	if mapheaderinfo[gamemap].lvlttl ~= "Arid Canyon" or mapheaderinfo[gamemap].actnum > 2 then return end
	if p.exiting then return end

	if string.lower(S_MusicName(p)) ~= "pepsjn" then
		S_ChangeMusic("pepsjn", true, p)
	end

	if p.speckipepsi == nil then
		p.speckipepsi = {
			angle = 0,
			speed = 0
		}
	end
	
	searchBlockmap("objects", function(specki, waypoint)
		p.speckipepsi.angle = waypoint.angle
		p.speckipepsi.speed = waypoint.spawnpoint.options*2*FRACUNIT
	end, p.mo, p.mo.x - 1024*FRACUNIT, p.mo.x + 1024*FRACUNIT, p.mo.y - 1024*FRACUNIT, p.mo.y + 1024*FRACUNIT)
	
	if p.powers[pw_carry] then return end
	
	p.mo.angle = $ - ($ - p.speckipepsi.angle)/TICRATE
	p.drawangle = p.mo.angle
	P_InstaThrust(p.mo, p.drawangle, p.speckipepsi.speed)
end)