-- holy fucking shit
-- morshu

freeslot(
	"MT_MORSHU",
	"S_MORSHU",
	"sfx_morshu",
	"SPR_MORS",
	"MT_RUPRING",
	"sfx_rupee",
	"S_SPECKI_SLICE",
	"S_SPECKI_DROPSLASH",
	"SPR2_SWOD"
)

states[S_MORSHU] = {
	sprite = SPR_MORS,
	frame = FF_ANIMATE,
	tics = -1,
	var1 = 25,
	var2 = 4
}

states[S_SPECKI_SLICE] = {
	sprite = SPR_PLAY,
	frame = SPR2_SWOD|FF_ANIMATE,
	tics = 8,
	var1 = 2,
	var2 = 3,
	nextstate = S_PLAY_STND
}

states[S_SPECKI_DROPSLASH] = {
	sprite = SPR_PLAY,
	frame = SPR2_SWOD|D,
	tics = -1,
	var1 = 0,
	var2 = 0
}

mobjinfo[MT_MORSHU] = {
	spawnhealth = 1,
	spawnstate = S_MORSHU,
	flags = MF_SOLID|MF_NOCLIPHEIGHT|MF_NOGRAVITY,
}

mobjinfo[MT_RUPRING] = {
	spawnstate = mobjinfo[MT_RING].spawnstate,
	deathstate = S_NULL,
	deathsound = sfx_rupee,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	speed = 38*FRACUNIT,
	painchance = 0,
	flags = MF_SLIDEME|MF_SPECIAL
}

local credit = {
	[10] = 125,
	[11] = 250
}

local rupees = 0

local lastmap = 0

addHook("MapLoad", function()
	if lastmap == gamemap then return end
	
	rupees = 0
	for p in players.iterate do
		p.rupees = 0
	end
	
	lastmap = gamemap
end)

addHook("MobjThinker", function(morshu)
	if not S_SoundPlaying(morshu, sfx_morshu) then
		S_StartSound(morshu, sfx_morshu)
	end
	
	for p in players.iterate do
		if not (p.mo and p.mo.valid) then return end
		if p.mo.skin ~= "specki" then return end
		if p.rupees == nil then continue end

		rupees = 0
		rupees = $+p.rupees
		
		if R_PointToDist2(morshu.x, morshu.y, p.mo.x, p.mo.y) <= 512*FRACUNIT and abs(morshu.z - p.mo.z) <= 512*FRACUNIT then		
			if rupees < credit[gamemap] then
				P_InstaThrust(p.mo, R_PointToAngle2(morshu.x, morshu.y, p.mo.x, p.mo.y), p.speed)
			end
		end
	end
end, MT_MORSHU)

addHook("MobjThinker", function(signpost)
	if mapheaderinfo[gamemap].lvlttl ~= "Castle Eggman" then return end

	for p in players.iterate do
		if not (p.mo and p.mo.valid) then return end
		if p.mo.skin ~= "specki" then return end
		local aggro = P_SpawnMobj(signpost.x, signpost.y, signpost.z, MT_MORSHU)
		aggro.scale = FRACUNIT/2
		aggro.angle = signpost.angle - ANGLE_90
		P_MoveOrigin(aggro, aggro.x + FixedMul(64*FRACUNIT, cos(aggro.angle + ANGLE_90)), aggro.y + FixedMul(64*FRACUNIT, sin(aggro.angle + ANGLE_90)), aggro.z)
		P_RemoveMobj(signpost)
		return
	end
end, MT_SIGN)

addHook("TouchSpecial", function(rupee, pmo)
	if not (pmo and pmo.valid) then return end
	if pmo.type ~= MT_PLAYER then return end
	if pmo.skin ~= "specki" then return end
	
	local p = pmo.player
	
	if rupee.specki ~= nil then
		if rupee.specki ~= pmo then return true end
	end
	
	if p.rupees == nil then p.rupees = 0 end
	
	if rupee.color == SKINCOLOR_RED then
		p.rupees = $+10 -- rupee
	elseif rupee.color == SKINCOLOR_BLUE then
		p.rupees = $+5 -- rupee
	else
		p.rupees = $+1 -- rupee
	end
	
	P_GivePlayerRings(pmo.player, 1)
	return false
end, MT_RUPRING)

addHook("MobjDeath", function(mobj, inf, pmo)
	if mapheaderinfo[gamemap].lvlttl ~= "Castle Eggman" then return end
	if not (pmo and pmo.valid) then return end
	if pmo.type ~= MT_PLAYER then return end
	if (not (mobj.flags & MF_ENEMY)) and (not (mobj.flags & MF_MONITOR)) then return end
	if pmo.skin ~= "specki" then return end
	
	local rupee = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_RUPRING)
	
	if mobj.flags2 & MF2_OBJECTFLIP then
		rupee.flags2 = $|MF2_OBJECTFLIP
	end
	
	if mobj.info.spawnhealth < 2 then
		if P_RandomChance(FRACUNIT/4)
			rupee.color = SKINCOLOR_BLUE
		else
			rupee.color = SKINCOLOR_EMERALD
		end
	else	
		if P_RandomChance(FRACUNIT/4) then
			rupee.color = SKINCOLOR_RED
		else
			rupee.color = SKINCOLOR_BLUE
		end
	end
	
	rupee.colorized = true
	rupee.momz = P_MobjFlip(rupee)*8*FRACUNIT
	rupee.specki = pmo
end)

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "specki" then return end
	if mapheaderinfo[gamemap].lvlttl ~= "Castle Eggman" then return end
	
	p.drawangle = p.mo.angle
	p.aiming = 0
	camera.chase = true
	camera.aiming = -FixedAngle(30*FRACUNIT)

	P_TryCameraMove(camera, p.mo.x - FixedMul(240*FRACUNIT, cos(camera.angle)), p.mo.y - FixedMul(240*FRACUNIT, sin(camera.angle)))
	
	if not P_IsObjectOnGround(p.mo) then
		camera.z = p.mo.z + 180*FRACUNIT
	else
		camera.z = p.mo.z + 240*FRACUNIT
	end
	
	if not (p.cmd.buttons & BT_ATTACK) then
		p.fireready = true
		p.firetap = false
	elseif p.fireready then
		p.firetap = true
		p.fireready = false
	else
		p.firetap = false
	end
	
	if P_PlayerInPain(p) then p.dropslash = false return end
	
	if p.firetap and (p.mo.state ~= S_SPECKI_SLICE and p.mo.state ~= S_SPECKI_DROPSLASH) then
		if P_IsObjectOnGround(p.mo) and not (p.pflags & PF_SPINNING) then
			p.mo.state = S_SPECKI_SLICE
			P_InstaThrust(p.mo, p.drawangle, 12*FRACUNIT)
		elseif (p.pflags & PF_JUMPED) then
			p.pflags = $ & ~(PF_JUMPED|PF_SPINNING)
			p.mo.state = S_SPECKI_DROPSLASH
			p.mo.sprite2 = SPR2_SWOD
			p.mo.frame = 3
			p.dropslash = true
			P_InstaThrust(p.mo, p.drawangle, p.speed/2)
			P_SetObjectMomZ(p.mo, 4*FRACUNIT, false)
		end
		
		p.speckiruntimer = 0
	end
	
	if P_IsObjectOnGround(p.mo) and p.dropslash then
		p.mo.state = S_PLAY_STND
		p.dropslash = false
		P_RadiusAttack(p.mo, p.mo, 256*FRACUNIT, 0, true)
		for i=1,8 do
			local dust = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SPINDUST)
			P_InstaThrust(dust, i*ANGLE_45, 16*FRACUNIT)
			P_RadiusAttack(dust, p.mo, 32*FRACUNIT, 0, true)
		end
		p.pflags = $ & ~PF_STASIS
	elseif p.mo.state == S_SPECKI_DROPSLASH then
		p.powers[pw_strong] = $|STR_ANIM|STR_SPRING
		p.pflags = $|PF_STASIS
		P_SetObjectMomZ(p.mo, -FRACUNIT/17, true)
	end
	
	if (p.mo.eflags & MFE_SPRUNG) then
		p.dropslash = false
	end
end)

addHook("PlayerCanDamage", function(p)
	if not (p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "specki" then return end
	
	if p.mo.state == S_SPECKI_SLICE or p.mo.state == S_SPECKI_DROPSLASH then
		return true
	end
end)

hud.add(function(v,p)
	if not (p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "specki" then return end
	if mapheaderinfo[gamemap].lvlttl ~= "Castle Eggman" then return end
	
	if P_IsObjectOnGround(p.mo) then
		v.drawString(316, 188, "FIRE: Attack", V_HUDTRANS|V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_PERPLAYER, "right")
	elseif (p.pflags & PF_JUMPED) then
		v.drawString(316, 188, "FIRE: Down Thrust", V_HUDTRANS|V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_PERPLAYER, "right")
	else
		v.drawString(316, 188, "FIRE: N/A", V_HUDTRANS|V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_PERPLAYER, "right")
	end
	
	if mapheaderinfo[gamemap].actnum > 2 then return end
	v.drawString(hudinfo[HUD_RINGS].x, hudinfo[HUD_RINGS].y + 32, "RUPEES: " .. tostring(rupees) .. "/" .. tostring(credit[gamemap]), V_HUDTRANS|V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER)
end, "game")

addHook("NetVars", function(net)
	rupees = net($)
end)