addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid) then return end
	if not p.mo.health then return end
	if p.mo.skin ~= "specki" then return end
	if mapheaderinfo[gamemap].lvlttl ~= "Techno Hill" then return end
	
	if (p.cmd.buttons & BT_ATTACK) and leveltime % 4 == 0 then
		local goop = P_SpawnMobj(p.mo.x+FixedMul(52*FRACUNIT, cos(p.mo.angle-ANGLE_90)), p.mo.y+FixedMul(52*FRACUNIT, sin(p.mo.angle-ANGLE_90)), p.mo.z+p.mo.height/2, MT_GOOP)
		goop.players = true
		P_Thrust(goop, p.mo.angle+FixedAngle(R_PointToDist2(p.mo.x, p.mo.y, goop.x, goop.y)/16), 36*FRACUNIT)
		P_SetObjectMomZ(goop, p.aiming/128, false)
		
		goop.flags = $|MF_MISSILE
		goop.fuse = 3*TICRATE
		goop.color = p.mo.color
		goop.colorized = true
	end
end)

addHook("ShouldDamage", function(pmo, inf, goop)
	if not (pmo and pmo.valid) then return end
	if not pmo.health then return end
	if not (goop and goop.valid) then return end
	if goop.type ~= MT_GOOP then return end
	if goop.players then return false end
end, MT_PLAYER)

addHook("ShouldDamage", function(aggro, inf, goop)
	if not (pmo and pmo.valid) then return end
	if not pmo.health then return end
	if not (goop and goop.valid) then return end
	if inf.type ~= MT_GOOP then return end
	if (aggro.flags & MF2_FRET) then return false end
	if goop.players then return true end
	
	return false
end, MT_AGGROPAINTER)

hud.add(function(v, p)
	if not (p.mo and p.mo.valid) then return end
	if not p.mo.health then return end
	if p.mo.skin ~= "specki" then return end
	if mapheaderinfo[gamemap].lvlttl ~= "Techno Hill" then return end
	
	if leveltime < 8*TICRATE then
		v.drawString(160, 120, "Hold Fire to shoot paint!", 0, "small-center")
		v.drawString(160, 128, "(first person recommended!!!)", 0, "small-center")
	end
end, "game")