freeslot(
	"MT_AGGROPAINTER",
	"S_AGGROPAINTER_IDLE",
	"S_AGGROPAINTER_PAINTSHOOT",
	"S_AGGROPAINTER_POGO",
	"S_AGGROPAINTER_POGO2",
	"S_AGGROPAINTER_POGO3",
	"S_AGGROPAINTER_POGO4",
	"S_AGGROPAINTER_POGO5",
	"S_AGGROPAINTER_POGO6",
	"S_AGGROPAINTER_POGO7",
	"S_AGGROPAINTER_PAIN",
	"S_AGGROPAINTER_PAIN2",
	"S_AGGROPAINTER_FLEE",
	"S_AGGROPAINTER_FLEE2",
	"S_AGGROPAINTER_DIE",
	"S_AGGROPAINTER_DIE2",
	"S_AGGROPAINTER_DIE3",
	"S_AGGROPAINTER_DIE4",
	"SPR_AGGP"
)

states[S_AGGROPAINTER_IDLE] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = -1,
	var1 = 0, 
	var2 = 0
}

states[S_AGGROPAINTER_PAINTSHOOT] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = 8,
	var1 = 0,
	var2 = 0,
	nextstate = S_AGGROPAINTER_IDLE
}

states[S_AGGROPAINTER_POGO] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = 4,
	var1 = 0, 
	var2 = 0,
	nextstate = S_AGGROPAINTER_POGO2
}

states[S_AGGROPAINTER_POGO2] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = 2,
	action = A_Boss2PogoTarget,
	var1 = 9*FRACUNIT, 
	var2 = 8*FRACUNIT,
	nextstate = S_AGGROPAINTER_POGO3
}

states[S_AGGROPAINTER_POGO3] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = 2,
	var1 = 0, 
	var2 = 0,
	nextstate = S_AGGROPAINTER_POGO4
}

states[S_AGGROPAINTER_POGO4] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = -1,
	var1 = 0, 
	var2 = 0
}

states[S_AGGROPAINTER_POGO5] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = 4,
	var1 = 0, 
	var2 = 0,
	nextstate = S_AGGROPAINTER_POGO6
}

states[S_AGGROPAINTER_POGO6] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = 2,
	action = A_Boss2PogoTarget,
	var1 = 7*FRACUNIT, 
	var2 = 8*FRACUNIT,
	nextstate = S_AGGROPAINTER_POGO7
}

states[S_AGGROPAINTER_POGO7] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = 2,
	var1 = 0, 
	var2 = 0,
	nextstate = S_AGGROPAINTER_POGO4
}

states[S_AGGROPAINTER_PAIN] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = 35,
	action = A_Boss2TakeDamage,
	var1 = 35+TICRATE, 
	var2 = 0,
	nextstate = S_AGGROPAINTER_IDLE
}

states[S_AGGROPAINTER_PAIN2] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = 35,
	action = A_Boss2TakeDamage,
	var1 = 35+TICRATE, 
	var2 = 0,
	nextstate = S_AGGROPAINTER_POGO4
}

states[S_AGGROPAINTER_FLEE] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = 2,
	var1 = 0, 
	var2 = 0,
	nextstate = S_AGGROPAINTER_FLEE2
}

states[S_AGGROPAINTER_FLEE2] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = 2,
	var1 = 0, 
	var2 = 0,
	nextstate = S_AGGROPAINTER_FLEE
}

states[S_AGGROPAINTER_DIE] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = 2,
	action = A_Fall,
	var1 = 0, 
	var2 = 0,
	nextstate = S_AGGROPAINTER_DIE2
}

states[S_AGGROPAINTER_DIE2] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = 5,
	action = A_BossScream,
	var1 = 0, 
	var2 = 0,
	nextstate = S_AGGROPAINTER_DIE3
}

states[S_AGGROPAINTER_DIE3] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = 0,
	action = A_Repeat,
	var1 = 17, 
	var2 = S_AGGROPAINTER_DIE2,
	nextstate = S_AGGROPAINTER_DIE4
}

states[S_AGGROPAINTER_DIE4] = {
	sprite = SPR_AGGP,
	frame = A,
	tics = -1,
	action = A_BossDeath,
	var1 = 0, 
	var2 = 0,
	nextstate = S_NULL
}

mobjinfo[MT_AGGROPAINTER] = {
	spawnhealth = 16,
	spawnstate = S_AGGROPAINTER_IDLE,
	seestate = S_NULL,
	attacksound = sfx_gspray,
	painstate = S_AGGROPAINTER_PAIN,
	painsound = sfx_dmpain,
	meleestate = S_AGGROPAINTER_PAIN2,
	missilestate = S_AGGROPAINTER_POGO,
	deathstate = S_AGGROPAINTER_DIE,
	xdeathstate = S_AGGROPAINTER_FLEE,
	deathsound = sfx_cybdth,
	activesound = sfx_pogo,
	raisestate = S_AGGROPAINTER_POGO2,
	reactiontime = -666,
	painchance = MT_GOOP,
	speed = FRACUNIT,
	radius = 24*FRACUNIT,
	height = 76*FRACUNIT,
	damage = 3,
	flags = MF_SPECIAL|MF_SHOOTABLE|MF_NOGRAVITY|MF_BOSS|MF_FLOAT
}

addHook("MobjThinker", function(egg)
	for p in players.iterate do
		if not (p.mo and p.mo.valid) then return end
		if p.mo.skin ~= "specki" and p.mo.skin ~= "mechaspecki" then return end
		if not egg and egg.valid then return end
		if not egg.health then return end
		local aggro = P_SpawnMobj(egg.x, egg.y, egg.z, MT_AGGROPAINTER)
		aggro.flags = egg.flags
		aggro.flags2 = egg.flags2|MF2_BOSSNOTRAP
		aggro.eflags = egg.eflags
		aggro.scale = egg.scale
		aggro.angle = egg.angle
		aggro.watertop = -aggro.info.speed
		if mapheaderinfo[gamemap].musname == "VSBOSS" then
			S_ChangeMusic("CONCPT", true)
		end
		P_RemoveMobj(egg)
		return true
	end
end, MT_EGGMOBILE2)

local function A_speckiBoss2Chase(actor)
	local radius
	local reverse = false
	local speedvar

	if (actor.health <= 0)
		return
	end

	// Startup randomness
	if (actor.reactiontime <= -666)
		actor.reactiontime = 2*TICRATE + P_RandomByte()
	end

	// When reactiontime hits zero, he will go the other way
	if (actor.reactiontime < 1)
		reverse = true
		actor.reactiontime = 2*TICRATE + P_RandomByte()
	end
	
	actor.reactiontime = $ - 1

	actor.target = P_GetClosestAxis(actor)

	if (not actor.target) // This should NEVER happen.
		CONS_Printf(player, "Boss2 has no target!\n")
		A_BossDeath(actor)
		return
	end

	radius = actor.target.radius

	if (reverse)
		actor.watertop = -actor.watertop
		actor.extravalue1 = 18
		if (actor.flags2 & MF2_AMBUSH)
			actor.extravalue1 = $ - (actor.info.spawnhealth - actor.health)*2
		end
		actor.extravalue2 = actor.extravalue1
	end

	// Turnaround
	if (actor.extravalue1 > 0)
		actor.extravalue1 = $ - 1

		// Set base angle

			local fa = (actor.target.angle + FixedAngle(actor.watertop))
			local fc = FixedMul(cos(fa),radius)
			local fs = FixedMul(sin(fa),radius)
			actor.angle = R_PointToAngle2(actor.x, actor.y, actor.target.x + fc, actor.target.y + fs)

		// Now turn you around!
		// Note that the start position is the final position, we move it back around
		// to intermediary positions...
		actor.angle = $ - FixedAngle(FixedMul(FixedDiv(180<<FRACBITS, actor.extravalue2<<FRACBITS), actor.extravalue1<<FRACBITS))
	else
		// Only speed up if you have the 'Deaf' flag.
		speedvar = 3 + (actor.health/4)

		actor.target.angle = $ + FixedAngle(FixedDiv(FixedMul(actor.watertop, (actor.info.spawnhealth*(FRACUNIT/4)*3)), speedvar*FRACUNIT))

		local fa = actor.target.angle
		local fc = FixedMul(cos(fa),radius)
		local fs = FixedMul(sin(fa),radius)
		actor.angle = R_PointToAngle2(actor.x, actor.y, actor.target.x + fc, actor.target.y + fs)
		P_MoveOrigin(actor, actor.target.x + fc, actor.target.y + fs, actor.z)
		
		if (leveltime % actor.health*6 == 0) then
			if not actor.tracer then
				P_LookForPlayers(actor, 16384*FRACUNIT, true, true)
				return
			end
			
			if P_RandomChance(FRACUNIT/8) then
				P_LookForPlayers(actor, 16384*FRACUNIT, true, true)
			end
			
			local goop = P_SpawnXYZMissile(actor, actor.tracer, MT_GOOP, actor.x+FixedMul(52*FRACUNIT, cos(actor.angle-ANGLE_90)), actor.y+FixedMul(52*FRACUNIT, sin(actor.angle-ANGLE_90)), actor.z+actor.height/2)
			
			if P_RandomChance(FRACUNIT/2) then
				P_Thrust(goop, goop.angle, R_PointToDist2(actor.x, actor.y, actor.tracer.x, actor.tracer.y)/24)
				P_SetObjectMomZ(goop, 0, false)
			else
				P_Thrust(goop, goop.angle, R_PointToDist2(actor.x, actor.y, actor.tracer.x, actor.tracer.y)/48)
				P_SetObjectMomZ(goop, R_PointToDist2(actor.x, actor.y, actor.tracer.x, actor.tracer.y)/TICRATE, false)
			end
			
			goop.fuse = 8*TICRATE
			goop.color = P_RandomRange(1, 68)
			goop.colorized = true
		end
	end
end

addHook("MobjThinker", function(goop)
	if goop.colorized then
		goop.frame = $|FF_FULLBRIGHT
	end
end, MT_GOOP)

addHook("MobjThinker", function(mobj)
	if (mobj.movecount) then
		mobj.movecount = $ - 1
	end

	if (not mobj.movecount) then
		mobj.flags2 = $ & ~MF2_FRET
	end

	if (not mobj.tracer)
	then
		A_BossJetFume(mobj, 0)
	end

	if (mobj.health <= mobj.info.damage and (not mobj.target or not (mobj.target.flags & MF_SHOOTABLE)))
	then
		if (mobj.health <= 0) then
			return
		end

		// look for a new target
		if (P_BossTargetPlayer(mobj, false) and mobj.info.seesound) then
			S_StartSound(mobj, mobj.info.seesound)
		end

		return
	end

	if (mobj.health > mobj.info.damage) then
		A_speckiBoss2Chase(mobj)
	elseif (mobj.health > 0 and mobj.state ~= mobj.info.painstate and mobj.state ~= mobj.info.raisestate)
	then
		A_speckiBoss2Chase(mobj)
		if (mobj.spawnpoint) then
			P_LinedefExecute(mobj.spawnpoint.args[4], mobj, NULL)
		end
	end
end, MT_AGGROPAINTER)